#include <stdio.h>
#include <stdlib.h>

// Anzahl Pixel
#define NUM_PIXELS 256*256

typedef unsigned char PIXEL;

/*** Hier geht der spannende Teil los ***/

void deinterlace(PIXEL *inimage, PIXEL *outimage)
{
  int i;
  unsigned short w;

	// Pixel am linken Rand nimmt Wert 128 für Nachbarn an
  w = (128 + inimage[0]) / 2;
  outimage[0] = w;

	// Nun alle weiteren Pixel bearbeiten
  for (i = 1; i < NUM_PIXELS; i++) {

		// Falls dies wieder ein Pixel am linken Rand ist ...
    if (i % 256 == 0) {

      // Alle 256 Pixel beginnt eine neue Zeile, default Pixelwert nehmen
      w = (128 + inimage [i]) / 2;

    } else {

			// sonst Mittelwert des letzten und dieses Originalpixels eintragen
      w = (inimage[i - 1] + inimage [i]) / 2;

    }
    outimage[i] = w;
  }
}

/*** Hier wird es wieder langweilig ***/

// einlesen einer passenden ppm datei

PIXEL *readimage(char *filename, PIXEL *image)
{
  FILE *infile = fopen(filename, "r");
  char buf[256];

  if (infile && image) {
    fgets(buf, 80, infile);   // skip P6
    //fgets(buf, 80, infile);   // skip # CREATOR
    fgets(buf, 80, infile);   // skip dimensions
    fgets(buf, 80, infile);   // skip depth
    fread(image, sizeof(PIXEL), NUM_PIXELS, infile);
    fclose(infile);
    return(image);
  }
  if (infile)
    fclose(infile);
}

// schreiben als ppm datei

void writeimage(char *filename, PIXEL *image)
{
  FILE *outfile = fopen(filename, "w");

  fputs("P5\n", outfile);
  //fputs("# CREATOR kludge\n", outfile);
  fputs("256 256\n", outfile);
  fputs("255\n", outfile);
  fwrite(image, sizeof(PIXEL), NUM_PIXELS, outfile);
  fclose(outfile);
}

// Hauptprogramm

main()
{
        // Benutze vorzeichenlose Ganzzahlen f"ur alle Variablen
        PIXEL *inimage, *outimage;

        // fordere Speicher f"ur Ein- und Ausgabearrays an
        inimage = malloc(2 * NUM_PIXELS * sizeof(PIXEL));
        outimage      = inimage      + NUM_PIXELS;

        if (!inimage) {
                fprintf(stderr, "out of memory\n");
                exit(1);
        }

        // Lese Quellbild
        readimage("lena256i.pgm", inimage);

        // Berechne
        deinterlace(inimage, outimage);

        // Gebe bearbeitetes Bild aus
        writeimage("lenaout.pgm", outimage);

        // Gebe Speicher f"ur Ein-/Ausgabe-Arrays  wieder frei
        free(inimage);
}
