//
//  user.v
//
//  Generische Slave-Mode Anwendung: Realisiert ein les-/schreibbares
//  Hardware-Register
//

module user(
  CLK,
  RESET,  
  ADDRESSED,
  WRITE,
  DATAIN,
  DATAOUT,
  ADDRESS,
  IRQ
);

  // Eing"ange
  input           CLK;
  input           RESET;
  input           ADDRESSED;
  input           WRITE;
  input  [31:0]   DATAIN;
  input  [23:2]   ADDRESS;

  // Ausg"ange
  output [31:0]   DATAOUT;
  output          IRQ;

  wire IRQ = 1'b0; // wird im Slave-Mode nicht gebraucht

  // Beginn der Anwendung **************************************************

  reg [31:0] outreg;          // Ergebnisregister

  // Ausgabedaten auf Bus legen
  // TODO Weitere Register anhand dekodierter Adresse anlegen
  // **** ...
  assign DATAOUT =  (ADDRESS[3:2] == 2'b00) ? outreg
                  : 32'hC0FFEE11;

  // Steuerung
  always @(posedge CLK or posedge RESET) begin
    // Initialisiere Register
    if (RESET) begin
      outreg  <= 32'hDEADBEEF;
      // TODO Weitere Register initialisieren
      // **** ...

    // Schreibzugriff auf RCU
    end else if ( ADDRESSED & WRITE) begin
      // TODO Hier weitere Register dekodieren
      // **** ...
      case (ADDRESS[3:2])
        2'b00:  outreg <= DATAIN;
        default: ;
      endcase
    end
  end

endmodule
